abstract class ExcludePathChecker {
  const ExcludePathChecker();

  static ExcludePathChecker excludePathCheckerStartsWith(String exclude) =>
      _ExcludePathCheckerImpl(
        predicate: (path) => path.startsWith(exclude),
        description: 'Starts with: $exclude',
      );

  static ExcludePathChecker excludePathCheckerEndsWith(String exclude) =>
      _ExcludePathCheckerImpl(
        predicate: (path) => path.endsWith(exclude),
        description: 'Ends with: $exclude',
      );

  static final excludePathDefaults = [
    excludePathCheckerStartsWith('l10n'),
    excludePathCheckerEndsWith('.g.dart'),
    excludePathCheckerEndsWith('.freezed.dart'),
  ];

  bool shouldExclude(String path);
}

class _ExcludePathCheckerImpl extends ExcludePathChecker {
  const _ExcludePathCheckerImpl(
      {required this.predicate, required this.description});
  final bool Function(String path) predicate;
  final String description;

  @override
  bool shouldExclude(String path) => predicate(path);
}